function [ im ] = Sensorimage( angle,measure, logodds )
% Angle    : radian, zero ->x ,ccw
% Measure  : m
global sensor dx
px(1)=0;
py(1)=0;
l=(measure+2*sensor.partw+sensor.platw)/cos(sensor.alpha/2);
px(2)=round(px(1)+l*cos(angle-sensor.alpha/2)/dx);
px(3)=round(px(1)+l*cos(angle+sensor.alpha/2)/dx);
py(2)=round(py(1)+l*sin(angle-sensor.alpha/2)/dx);
py(3)=round(py(1)+l*sin(angle+sensor.alpha/2)/dx);

[xmin,xmini]=min(px);
[ymin,ymini]=min(py);
[xmax,xmaxi]=max(px);
[ymax,ymaxi]=max(py);
xs=px(1)-xmin;
ys=py(1)-ymin;
im.width=xmax-xmin+1;
im.height=ymax-ymin+1;
if logodds==1
        im.im=zeros(im.width,im.height);
else
        im.im=ones(im.width,im.height);
end
%calculate triangle points
for i=1:3
    px(i)=px(i)+xs+1;
    py(i)=py(i)+ys+1;
    im.im(px(i),py(i))=1;
end
px(4)=px(1);
py(4)=py(1);
im.px=px(1);
im.py=py(1);
%draw triangle
for i=1:3
    vx=px(i+1)-px(i);
    vy=py(i+1)-py(i);
    d=sqrt(vx^2+vy^2);
    vx=vx/d;
    vy=vy/d;
    x=px(i);
    y=py(i);
    for p=0:.5:d
        im.im(round(x),round(y))=1;
        x=x+0.5*vx;
        y=y+0.5*vy;
    end
end
%scan points
for by=1:im.height
    for bx=1:im.width
        if im.im(bx,by)==1
            break;
        else
            if logodds==1
                im.im(bx,by)=0;
            else
                im.im(bx,by)=sensor.PMi;
            end
        end
    end
    for ex=im.width:-1:1
        if im.im(ex,by)==1
            break;
        else
            if logodds==1
                im.im(ex,by)=0;
            else
                im.im(ex,by)=sensor.PMi;
            end
        end
    end
    for x=bx:ex
        d=sqrt( (x-px(1))^2+(by-py(1))^2 )*dx;
        meas=measure;dist=d; 
        
        %inv_sensor_modell(measure,d,sensor);
        if measure<sensor.maxdist
                if dist<=(meas-sensor.platw-sensor.partw)
                    prob=sensor.PLo;
                elseif dist<meas-sensor.platw
                    prob= (dist-meas+sensor.partw+sensor.platw)/sensor.partw*(sensor.PHi-sensor.PLo)+sensor.PLo;
                elseif dist<meas+sensor.platw
                    prob=sensor.PHi;
                elseif dist<meas+sensor.platw+sensor.partw
                    prob=(dist-meas-sensor.partw-sensor.platw)/sensor.partw*(sensor.PMi-sensor.PHi)+sensor.PMi;
                else
                    prob=sensor.PMi;
                end            

        else
            if dist<sensor.maxdist
                prob=sensor.PLo;
            else
                prob=sensor.PMi;
            end
        end
     
        if logodds==1
            prob=log(prob/(1-prob));
        else
            prob=inv_sensor_modell(measure,d,sensor);
        end    
            im.im(x,by)=prob;
        end
    end
end

